﻿using AutomobilePlantContracts.BindingModels;
using AutomobilePlantContracts.ViewModels;

namespace AutomobilePlantContracts.BusinessLogicsContracts
{
    public interface IReportLogic
    {
        /// <summary>
        /// Получение списка компонент с указанием, в каких изделиях используются
        /// </summary>
        /// <returns></returns>
        List<ReportCarComponentViewModel> GetCarComponents();
        /// <summary>
        /// Получение списка заказов за определенный период
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        List<ReportOrdersViewModel> GetOrders(ReportBindingModel model);
        /// <summary>
        /// Сохранение машин в файл-Word
        /// </summary>
        /// <param name="model"></param>
        void SaveCarsToWordFile(ReportBindingModel model);
        /// <summary>
        /// Сохранение компонент с указаеним продуктов в файл-Excel
        /// </summary>
        /// <param name="model"></param>
        void SaveCarComponentToExcelFile(ReportBindingModel model);
        /// <summary>
        /// Сохранение заказов в файл-Pdf
        /// </summary>
        /// <param name="model"></param>
        void SaveOrdersToPdfFile(ReportBindingModel model);
        /// <summary>
        /// Сохранение магазинов в файл-Word
        /// </summary>
        /// <param name="model"></param>
        void SaveShopsToWordFile(ReportBindingModel model);
        /// <summary>
        /// Сохранение магазинов с указаеним продуктов в файл-Excel
        /// </summary>
        /// <param name="model"></param>
        void SaveShopCarsToExcelFile(ReportBindingModel model);
        /// <summary>
        /// Получение списка магазинов
        /// </summary>
        /// <returns></returns>
        List<ReportShopCarsViewModel> GetShopCars();
        /// <summary>
        /// Получение списка заказов с группировкой по датам
        /// </summary>
        /// <returns></returns>
        List<ReportDateOrdersViewModel> GetDateOrders();
        /// <summary>
        /// Сохранение заказов с группировкой по датам в файл-Pdf
        /// </summary>
        /// <param name="model"></param>
        void SaveDateOrdersToPdfFile(ReportBindingModel model);
    }

}
